$|=1; # line buffering

$swroot = '/var/smoothwall';
$pagecolour = '#ffffff';
$bigboxcolour = '#e8ffe8';
$boxcolour = '#ffffff';
$bordercolour = '#000000';
$table1colour = '#ffffff';
$table2colour = '#c0ffc0';

sub showmenu
{
	print <<END
<TABLE WIDTH='100%' BORDER='0'>
<TR><TD BGCOLOR='$bordercolour' ALIGN='CENTER' VALIGN='MIDDLE'>
<TABLE WIDTH='100%' BORDER='0' CELLPADDING='5'>
<TR><TD BGCOLOR='$bigboxcolour'>
<DIV ALIGN='CENTER'>
<FONT SIZE='2'>
<A HREF='/cgi-bin/index.cgi'>Home</A> |
<A HREF='/cgi-bin/status.cgi'>Status</A> |
<A HREF='/ipac/'>Graphs</A> |
<A HREF='/cgi-bin/pppsetup.cgi'>PPP</A> |
<A HREF='/cgi-bin/changepw.cgi'>Passwords</A> |
<A HREF='/cgi-bin/remote.cgi'>Remote&nbsp;access</A> |
<A HREF='/cgi-bin/dhcp.cgi'>DHCP</A> |
<A HREF='/cgi-bin/shutdown.cgi'>Shutdown</A> |
<A HREF='/cgi-bin/logs.cgi'>Logs</A> |
<A HREF='/cgi-bin/firewall.cgi'>Firewall&nbsp;logs</A>
</FONT>
</DIV>
</TD></TR>
</TABLE>
</TD></TR>
</TABLE>
END
	;
}

sub openpage
{
	$title = $_[0];
	$menu = $_[1];

	print <<END
<HTML>
<HEAD>
<TITLE>SmoothWall - $title</TITLE>
</HEAD>
<BODY BGCOLOR='$pagecolour'>
END
	;
	if ($menu == 1) {
		&showmenu(); }
}

sub closepage
{
	print <<END
</BODY>
</HTML>
END
	;
}

sub openbigbox
{
	$width = $_[0];
	$align = $_[1];

	print <<END
<TABLE WIDTH='$width' BORDER='0'>
<TR><TD BGCOLOR='$bordercolour' ALIGN='CENTER' VALIGN='MIDDLE'>
<TABLE WIDTH='100%' CELLSPACING='2' CELLPADDING='5' BORDER='0'>
<TR><TD BGCOLOR='$bigboxcolour' ALIGN='$align'>
END
	;
}

sub closebigbox
{
	print <<END
</TD></TR>
</TABLE>
</TD></TR>
</TABLE>
END
	;
}

sub openbox
{
	$width = $_[0];
	$align = $_[1];
	$caption = $_[2];

	if ($caption) { print "<B>$caption</B>\n"; }

	print <<END
<TABLE WIDTH='$width' BORDER='0'>
<TR><TD ALIGN='CENTER' BGCOLOR='$bordercolour' VALIGN='MIDDLE'>
<TABLE WIDTH='100%' CELLSPACING='1' CELLPADDING='5' BORDER='0'>
<TR><TD BGCOLOR='$boxcolour' ALIGN='$align'>                             
END
	;
}

sub closebox
{
	print <<END
</TD></TR>
</TABLE>
</TD></TR>
</TABLE>
<BR>
END
	;
}

sub writehash
{
	my $filename = $_[0];
	my $hash = $_[1];
	
	# write cgi vars to the file.
	open(FILE, ">${filename}") or die "Unable to write file $filename";

	foreach $var (keys %$hash) 
	{
		$val = $hash->{$var};
		if (!($var =~ /^ACTION/)) {
			print FILE "${var}=${val}\n"; }
	}
	close FILE;
}

sub readhash
{
	my $filename = $_[0];
	my $hash = $_[1];
	my ($var, $val);

	open(FILE, $filename) or die "Unable to read file $filename";
	
	while (<FILE>)
	{
		chop;
		($var, $val) = split /=/, $_, 2;
		if ($var) {
			$hash->{$var} = $val; }
	}
	close FILE;
}

sub getcgihash
{
	my $hash = $_[0];
	my $buffer = '';
	my $length = $ENV{'CONTENT_LENGTH'};
	my ($name, $value); 
	my ($pair, @pairs);
	my %hash;

	if ($ENV{'REQUEST_METHOD'} ne 'POST') {
		return; }

	read(STDIN, $buffer, $length);
	
	# Split the name-value pairs
	@pairs = split(/&/, $buffer);

	foreach $pair (@pairs)
	{
		($name, $value) = split(/=/, $pair);
		next unless $name; # fields MUST BE named!

		# Convert hex to ASCII
		$value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack('C', hex($1))/eg;
		$value =~ s/\+/ /g;

		# Strip out naughty characters -- this is a confusing line, huh?
		# Really it's just a list of characters allowed in the string.
		$value =~ s/[^\w\013\n!@#\$%\^\*()_\-\+=\{\}\[\]\\|;:\'\"<,>\.?\/`~ ]//g;
		$hash->{$name} = $value;
    }
    return %hash;
}

sub log
{
	system('/usr/bin/logger', '-t', 'smoothwall', $_[0]);
}